<template>
  <!-- Scatter or line? -->
  <div v-if="attributes === null">Waiting...</div>
  <apexchart
    v-else
    :options="chartOptions"
    :series="series"
    type="scatter"
    class="w-full"
  />
</template>

<script>
import { mapState } from "vuex";

export default {
  computed: {
    ...mapState(["modelCategory", "attributes", "selectedAttribute"]),

    chartOptions() {
      const selected = this.attributes[this.selectedAttribute];

      // const minContribution = Math.min(
      return {
        chart: {
          id: "prognostic_model__attributes",
          type: "scatter",
          toolbar: {
            show: true,
            tools: {
              zoom: true,
              zoomin: true,
              zoomout: true
            }
          },
          zoom: {
            enabled: true,
            type: "x",
            zoomedArea: {
              fill: {
                color: "#00acac",
                opacity: 0.4
              },
              stroke: {
                color: "#00acac",
                opacity: 0.4,
                width: 1
              }
            }
          }
        },
        tooltip: {
          x: {
            formatter: value => `
              Contribution ${Math.round(value * 1000) / 1000}
            `
          }
        },
        stroke: {
          show: false
        },
        markers: {
          size: 6
        },
        colors: ["#3182CE", "#319795", "#DD6B20", "#E53E3E"],
        xaxis: {
          type: "numeric",
          labels: {
            formatter(value) {
              return Math.round(value * 1000) / 1000;
            }
          },
          title: {
            text: "Contribution",
            offsetY: 10,
            style: {
              cssClass: "f-subtitle"
            }
          }
        },
        yaxis: {
          labels: {
            formatter(value) {
              const length = selected.y_categories.length;
              const index = Math.round(value);
              if (index === 0 || index > length) return "";
              return selected.y_categories[index - 1];
            },
            minWidth: 120
          },
          title: {
            text: "Attribute value",
            rotate: 90,
            style: {
              cssClass: "f-subtitle"
            }
          },
          min: 0,
          max: selected.y_categories.length + 1,
          tickAmount: selected.y_categories.length + 1
        },
        legend: {
          height: 72,
          offsetX: 120,
          offsetY: -16
        }
      };
    },
    series() {
      const selected = this.attributes[this.selectedAttribute];

      /* Remember to fix +1 */
      return [
        {
          name: "Satisfactory [with surgery]",
          data: selected.blue_o_points.map(p => [p[0], p[1] + 1])
        },
        {
          name: "Satisfactory [without surgery]",
          data: selected.blue_x_points.map(p => [p[0], p[1] + 1])
        },
        {
          name: "Unsatisfactory [with surgery]",
          data: selected.red_o_points.map(p => [p[0], p[1] + 1])
        },
        {
          name: "Unsatisfactory [without surgery]",
          data: selected.red_x_points.map(p => [p[0], p[1] + 1])
        }
      ];
    }
  }
};
</script>
